diff --git a/src/main/java/net/minecraft/core/item/ItemStack.java b/src/main/java/net/minecraft/core/item/ItemStack.java
index 3a2701f5d..291847976 100644
--- a/src/main/java/net/minecraft/core/item/ItemStack.java
+++ b/src/main/java/net/minecraft/core/item/ItemStack.java
@@ -4,25 +4,27 @@ import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.Global;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.net.command.TextFormatting;
-import net.minecraft.core.player.inventory.IInventory;
+import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.save.conversion.ChunkConverter;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public final class ItemStack
-{
+
+public final class ItemStack {
     public static ItemStack NO_ITEM = new ItemStack();
 
     public int stackSize;
     public int animationsToGo;
     public int itemID;
     private int metadata;
+
     @NotNull
     private CompoundTag tag;
 
@@ -120,12 +122,12 @@ public final class ItemStack
         return Item.itemsList[itemID];
     }
 
-    public boolean useItem(EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
+    public boolean useItem(Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
     {
         boolean flag = getItem().onUseItemOnBlock(this, entityplayer, world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
         if(flag)
         {
-            entityplayer.addStat(StatList.usedItemStats[itemID], 1);
+            entityplayer.addStat(getItem().getStat(StatList.STAT_USED), 1);
         }
         return flag;
     }
@@ -135,7 +137,7 @@ public final class ItemStack
         return getItem().getStrVsBlock(this, block);
     }
 
-    public ItemStack useItemRightClick(World world, EntityPlayer entityplayer)
+    public ItemStack useItemRightClick(World world, Player entityplayer)
     {
         return getItem().onUseItem(this, world, entityplayer);
     }
@@ -189,7 +191,7 @@ public final class ItemStack
 			Thread.dumpStack();
 			tag.getValue().remove("overrideColor");
 		}
-		if(tag.getBoolean("overrideName") && (!tag.containsKey("name") || tag.getString("name").length() == 0)) {
+		if(tag.getBoolean("overrideName") && (!tag.containsKey("name") || tag.getString("name").isEmpty())) {
 			System.err.println("Item has override name tag but no custom name!");
 			Thread.dumpStack();
 			tag.getValue().remove("overrideName");
@@ -199,8 +201,8 @@ public final class ItemStack
 			itemID = 0;
 		}
 		
-		if(itemID == Block.chestLegacy.id) itemID = Block.chestPlanksOak.id;
-		if(itemID == Block.chestLegacyPainted.id) itemID = Block.chestPlanksOakPainted.id;
+		if(itemID == Blocks.CHEST_LEGACY.id) itemID = Blocks.CHEST_PLANKS_OAK.id;
+		if(itemID == Blocks.CHEST_LEGACY_PAINTED.id) itemID = Blocks.CHEST_PLANKS_OAK_PAINTED.id;
 	}
 
     public int getMaxStackSize()
@@ -208,7 +210,7 @@ public final class ItemStack
         return getItem().getItemStackLimit();
     }
 
-    public int getMaxStackSize(IInventory inv)
+    public int getMaxStackSize(Container inv)
     {
         return getMaxStackSize();
     }
@@ -256,8 +258,8 @@ public final class ItemStack
 
     public void damageItem(int i, Entity entity)
     {
-        if (entity instanceof EntityPlayer) {
-            if (!((EntityPlayer)entity).getGamemode().toolDurability()) return;
+        if (entity instanceof Player) {
+            if (!((Player)entity).getGamemode().toolDurability()) return;
         }
         if(!isItemStackDamageable())
         {
@@ -266,9 +268,9 @@ public final class ItemStack
         metadata += i;
         if(metadata > getMaxDamage())
         {
-            if(entity instanceof EntityPlayer)
+            if(entity instanceof Player)
             {
-                ((EntityPlayer)entity).addStat(StatList.breakItemStats[itemID], 1);
+                ((Player)entity).addStat(getItem().getStat(StatList.STAT_DEPLETED), 1);
             }
             stackSize--;
             if(stackSize < 0)
@@ -290,30 +292,30 @@ public final class ItemStack
         metadata -= i;
     }
 
-    public void hitEntity(EntityLiving entityliving, EntityPlayer entityplayer)
+    public void hitEntity(Mob entityliving, Player entityplayer)
     {
         boolean flag = Item.itemsList[itemID].hitEntity(this, entityliving, entityplayer);
         if(flag)
         {
-            entityplayer.addStat(StatList.usedItemStats[itemID], 1);
+            entityplayer.addStat(getItem().getStat(StatList.STAT_USED), 1);
         }
     }
     
-    public boolean beforeDestroyBlock(World world, int id, int x, int y, int z, Side side, EntityPlayer player)
+    public boolean beforeDestroyBlock(World world, int id, int x, int y, int z, Side side, Player player)
     {
     	return getItem().beforeDestroyBlock(world, this, id, x, y, z, side, player);
     }
 
-    public void onDestroyBlock(World world, int id, int x, int y, int z, Side side, EntityPlayer entityplayer)
+    public void onDestroyBlock(World world, int id, int x, int y, int z, Side side, Player entityplayer)
     {
         boolean flag = Item.itemsList[itemID].onBlockDestroyed(world, this, id, x, y, z, side, entityplayer);
         if(flag)
         {
-            entityplayer.addStat(StatList.usedItemStats[itemID], 1);
+            entityplayer.addStat(getItem().getStat(StatList.STAT_USED), 1);
         }
     }
 
-    public boolean consumeItem(EntityPlayer entityplayer){
+    public boolean consumeItem(Player entityplayer){
         if(stackSize <= 0)
             return false;
         if (entityplayer.getGamemode().consumeBlocks()) {
@@ -327,12 +329,12 @@ public final class ItemStack
         return Item.itemsList[itemID].getDamageVsEntity(entity);
     }
 
-    public boolean canHarvestBlock(EntityLiving entityLiving, Block block)
+    public boolean canHarvestBlock(Mob entityLiving, Block block)
     {
         return Item.itemsList[itemID].canHarvestBlock(entityLiving, this, block);
     }
 
-    public boolean useItemOnEntity(EntityLiving entityliving, EntityPlayer entityPlayer)
+    public boolean useItemOnEntity(Mob entityliving, Player entityPlayer)
     {
         return Item.itemsList[itemID].useItemOnEntity(this, entityliving, entityPlayer);
     }
@@ -403,9 +405,9 @@ public final class ItemStack
         Item.itemsList[itemID].inventoryTick(this, world, entity, i, flag);
     }
 
-    public void onCrafting(World world, EntityPlayer entityplayer)
+    public void onCrafting(World world, Player entityplayer)
     {
-        entityplayer.addStat(StatList.craftedItemStats[itemID], stackSize);
+        entityplayer.addStat(getItem().getStat(StatList.STAT_CRAFTED), stackSize);
         Item.itemsList[itemID].onCraftedBy(this, world, entityplayer);
     }
 
@@ -443,11 +445,11 @@ public final class ItemStack
     }
 
     public boolean hasCustomName() {
-    	return tag.getBoolean("overrideName");
+        return tag.getBoolean("overrideName");
     }
     
     public boolean hasCustomColor() {
-    	return tag.getBoolean("overrideColor");
+        return tag.getBoolean("overrideColor");
     }
     
     public String getCustomName() {
@@ -477,13 +479,13 @@ public final class ItemStack
     	}
     	return 0;
     }
-    
+
     public void setCustomName(@Nullable String name) {
-    	if(name == null || name.length() == 0) {
+        if(name == null || name.isEmpty()) {
     		removeCustomName();
     		return;
     	}
-    	tag.putBoolean("overrideName", true);
+        tag.putBoolean("overrideName", true);
     	tag.putString("name", name);
     }
     
@@ -492,17 +494,17 @@ public final class ItemStack
     		removeCustomColor();
     		return;
     	}
-    	tag.putBoolean("overrideColor", true);
+        tag.putBoolean("overrideColor", true);
     	tag.putByte("color", color);
     }
     
     public void removeCustomName() {
-		tag.getValue().remove("overrideName");
+        tag.getValue().remove("overrideName");
 		tag.getValue().remove("name");
     }
     
     public void removeCustomColor() {
-		tag.getValue().remove("overrideColor");
+        tag.getValue().remove("overrideColor");
 		tag.getValue().remove("color");
     }
 
